<?xml version="1.0"?>
<xsl:stylesheet version="1.0" extension-element-prefixes="dp regexp"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dp="http://www.datapower.com/extensions"
    xmlns:regexp="http://exslt.org/regular-expressions">

  <dp:input-mapping href="store:///pkcs7-convert-input.ffd" type="ffd"/>
  <dp:output-mapping href="store:///pkcs7-convert-input.ffd" type="ffd"/>

  <xsl:template match="/">
    <xsl:variable name="raw-data" select="dp:decode(dp:binary-encode(/object/message/node()), 'base-64')"/>
    <xsl:variable name="htmlwodt">
      <xsl:choose>
        <xsl:when test="starts-with($raw-data, '&lt;!DOCTYPE')">
          <xsl:value-of select="substring-after($raw-data, '&gt;')"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$raw-data"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="result" select="regexp:replace($htmlwodt, '&amp;', 'g', '&amp;amp;')"/>
    <object>
      <message>
        <xsl:copy-of select="dp:binary-decode(dp:encode($result, 'base-64'))"/>
      </message>
    </object>
  </xsl:template>
</xsl:stylesheet>
